<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>Caroline Rudd</title>

<!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

<!-- Bootstrap -->
  <link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="plugins/themify/css/themify-icons.css">


<!-- Main Stylesheet -->
  <link href="css/style.css" rel="stylesheet">
<!-- Navigation Start -->
<!-- Header Start -->
<head>

<ul>
  <li><a href="index.html">Home</a></li>
  <li><a href="about.html">About</a></li>
  <li><a href="DataDiet.html">Data Diet</a></li>
  <li><a href="term1.html">Term 1</a></li>
  <li><a href="term2.html">Term 2</a></li>
  <li><a href="term3.html">Term 3</a></li>
  <li><a class="active" href="Fabacademy.html">FAB Academy</a></li>
</ul>
</head>

<!-- Header Close -->

<div style="margin-left:10%;padding:1px 10px;height:1000px;">


<section class="page-title section pb-0">
  <div class="container">
    <div class="row">
      <div class="col-lg-12">
        <div class="text-center">
          <h1 class="text-capitalize mb-0 text-lg">Interfaces and Applications</h1>
        </div>
      </div>
    </div>
  </div>
</section>


<section class="section portfolio-single">
	<div class="container">
		<div class="row justify-content-center">
			<div class="col-lg-8">
				<div class="project-info">
					<h3 class="mb-4"></h3>
<p>Lately I've been really into learning Processing, so for this week I knew I wanted to use that as my interface, and then also connect it with my Arduino for the sensor input. Since I'm still pretty new to coding, I followed <a href="https://www.youtube.com/watch?v=JvmIutmQd9U"> <strong>this tutorial</strong></a> for my first try, which showed me how to connect my Ultrasonic sensor and micro servo 9g motor through Arduino, and build a radar interface within Processing that would detect and show if an object was within range of the sensor.
<br><br>
First I connected the sensor to the motor with hair ties (this was all I had laying around), and then I connected all the cables between sensor, motor, breadboard, and my mega 2560 board. I used double sided tape to secure the motor and mega onto the breadboard. Once everything was connected, it was time to move on to the coding side of things.
<br><br>
  <img src="images/FAB/week12/ArduinoSetup.png" alt="" class="img-fluid w-100">
 <br><br>
I started with Arduino first in order to get the sensor working and rotating properly. Although I did not write the code myself, this process did help me understand more about connecting sensors with motors, as this was my first time doing it on my own. The main variables involved in this process were distance and angle degree. The motor steadily rotated back & forth from 15-165 degrees, while the sensor simultaneously calculated the distance in cm from objects.
 <br><br>
 <video class="videopost" controls muted width="100%" height="50%" controls>
                 <source src="images/FAB/mp4s/RotatingSensor4Interfacing.mp4" type="video/mp4" autostart="false" />
                 </video>
 <br><br>
 Next was the Processing coding. Although this was also not my code, I still had to make a few changes to it, like the screen resolution and the port name. I also added my name to it and slightly changed the green color of the radar. Here, I learned that processing reads the data (angle & distance) from the sensor through the port. I also realized that Processing converts the distance from the sensor from cm to pixels, limiting the range 40 cms. This was surprising to me, as before this I assumed that a distance limit would've been set by the sensor and/or the Arduino code, rather than in the interfacing of it.
 <video width="100%" height="600" controls><source src="images/FAB/mp4s/RadarInterface.mp4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
As you can see in the video, the sensor identified the coffee cup and my computer screen where the red lines showed up on the interface. Overall, this process really illuminated to me how important interfaces are, as you can have sensors and tons of data being collected, but if you're not able to properly read and understand the information, then it's useless.
<br><br>
To continue, like I said, I've been really into Processing, so I wanted to keep trying different inputs with this program. For my second experiment, I wanted to try a bit with generative art coding, and using the keyboard as the input. To begin, I followed <a href="https://www.youtube.com/watch?v=LaarVR1AOvs"> <strong>this tutorial</strong></a> about using parametric equations and sinusoidal functions in generative art.
<br><br>
While following along with the coding in the video, I first created a dot in the middle of the screen, and then a dot that drew a line off the screen, and then drew waves, and eventually a circle. Two of my first steps can be seen below.

<video width="600" height="600" controls><source src="images/FAB/week12/1stStep.MP4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
<video width="600" height="600" controls><source src="images/FAB/week12/2ndStep.MP4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
Finally I had coded my first moving sequence of lines.

<video width="600" height="600" controls><source src="images/FAB/week12/1stLine.MP4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
& then I played around with movement of this line a bit.
<br><br>
<video width="600" height="600" controls><source src="images/FAB/week12/PlayingW1stLine.MP4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
Then I added in a second line sequence by adding an x3/y3 and x4/y4 drawing and float elements, and played around with the math a bit (again) until I created some shapes/paths I liked.
<br><br>
<img src="images/FAB/week12/Adding2ndLine-Code.png" alt="" class="img-fluid w-100">
<br><br>
<video width="600" height="600" controls><source src="images/FAB/week12/PostedLines.MP4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
At this point, the tutorial was finished, but I wanted to keep playing around with all the parameters and see what I could come up with. I first added colors (rather than grayscale) to the lines with rgb inputs. I then continued to change and play with number of lines in each sequence, the speed, and changing up the math in the float equations a ton with sin, cos, and a large range of numbers. I also decided at one point to add a third sequence of lines by creating x5/y5 and x6/y6 elements.
<br><br>
<video width="600" height="600" controls><source src="images/FAB/week12/3Lines.MP4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
I had also been reading and seeing videos about float elements, so I decided to add more of these in the beginning of the code, with random numbers (float a =random(50, 200)) in order to randomize it so that every time I ran the code it would generate a new series of lines. This was my first time creating generative art, and it was so fun to see all the different combinations every time.
<br><br>
<video width="600" height="600" controls><source src="images/FAB/week12/Randomized.MP4" type="video/mp4">Your browser does not support the video tag.</video>
<br><br>
In regards to inputs however, I wanted to make it so that only the second sequence of lines would appear and run one full rotation of it's "path" if a key was pressed. This turned out to be harder than I expected. By moving the code around a bit, and adding the keyPressed function, the second line sequence would appear, but only for one loop. So you can only see one frame of the sequence before it goes away almost immediately, making the only way to continually see the line is by holding the key down, and even then the line sequence still flashes for each "pressing of the key" rather than continually running one full rotation, like I intended for.
<br><br>
<video width="600" height="600" controls><source src="images/FAB/week12/FailedKeyPressed-3.MP4" type="video/mp4">Your browser does not support the video tag.</video>

<br><br>
I then tried a few different codes that I had read about, but couldn't get any of them to work. I tried boolean: Boolean going = false; & then going = true; under the keyPressed command but I couldn't get it to work. I also tried if/else statements, and tried loop: Void keyPressed(){ Loop(); But none worked for me.
<br><br>
<b> Files: </b><a href="images/FAB/Downloads/Interfacing/Radar-Rotating_sensor_with_motor.ino" download> Arduino
  <a href="images/FAB/Downloads/Interfacing/InterfacingWSensors_Radar.pde" download>Processing for Radar
</a></a>
</div>




				<div class="row mt-4">
					<div class="col-lg-6">
						<div class="info">
							<h5 class="mb-0">Student</h5>
							<p>Caroline Rudd</p>
						</div>

						<div class="info">
							<h5 class="mb-0">Year</h5>
							<p>2020</p>
						</div>
					</div>

				<div class="mt-5">
					<a href=".html" class="btn btn-dark">Previous Work</a>
					<a href="FAB13_WildCard.html" class="btn btn-dark">Next Work</a>
				</div>
			</div>
		</div>
	</div>
</section>


<section class="footer">
	<div class="container">
		<div class="row ">
			<div class="col-lg-6">
				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
					<ul class="list-inline mb-0">

						<li class="list-inline-item"><a href="https://github.com/themefisher/" target="_blank"><i class="ti-github mr-3"></i></a></li>
						<li class="list-inline-item"><a href="https://www.linkedin.com/in/caroline-rudd-75208b181/" target="_blank"><i class="ti-linkedin mr-3"></i></a></li>
	           </li>
        	</ul>
				</div>
			</div>
		</div>
	</div>
</section>
<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>


<!-- Main Script -->
<script src="js/script.js"></script>

</html>
